#include "stdafx.h"

#include "cubeData.hpp"
#include "op.h"

using namespace Yang;
using namespace std;
//need set zero if bAdd == false

////not finished yet
bool op::dot_test(bool verbose) {
   cubeData<float> mod1,mod2,dat1,dat2;
   
   VERIFY(!modShape.isEmpty());
   VERIFY(!datShape.isEmpty());

   mod1.alloc(modShape);
   dat2.alloc(datShape);
   
   mod1.allocMemoryTo(mod2);
   dat2.allocMemoryTo(dat1);
   
   //Generate random numbers for mod
   long long nMod = modShape.get_n123();
   long long nDat = datShape.get_n123();
   
   //generate from 0~1 uniform random numbers
   srand(time(NULL));
   long long i;
   for (i=0; i<nMod; i++) {
     mod1[i] = float(rand())/float(RAND_MAX);
   }
   for (i=0; i<nDat; i++) {
     dat2[i] = float(rand())/float(RAND_MAX);
   }
   
   verbPrt("\nINITIAL DATA in DotTest\n");
   
   //do forward
   bool bAdj =  false;
   this->oper(mod1,dat1,bAdj,false);
   float dot1=dotProd(dat1,dat2);
   //do adj
   this->oper(mod2,dat2,!bAdj,false);
   double dot2=dotProd(mod2,mod1);

   verbPrt("Dot(add=false) %g %g \n",dot1,dot2);
    
   float dot3=1.0f;    
   /*
   forward(true,mod1,dat1);
   adjoint(true,mod2,dat2);

   double dot3=mod1->dot(mod2);
   double dot4=dat1->dot(dat2);
   verbPrt("Dot(add=true) %g %g \n",dot4,dot3);

   if(fabs( (dot3-dot4)/dot3) >.0001) {
     verbPrt("Failed add=true dot product  %g (%g %g) \n",fabs( (dot3-dot4)/dot3),dot3,dot4);
     return false;
   }
   */
   
   if(fabs(dot1) < 1e-12 || fabs(dot3) < 1e-12) {
     verbPrt("Dot product suspiciously small\n");
     return false;
   }
   
   if(fabs( (dot1-dot2)/dot1) >.0001) {
     verbPrt("Failed add=false dot product %g %g\n",dot1,dot2);
     return false;
  }
  
   return true;
}


//bool op::dot_test(bool verbose)
//{
//   gVec *mod1,*mod2,*dat1,*dat2;
//   
//   mod1=domain->clone_vec();
//   mod2=mod1->clone_vec();
//   dat1=range->clone_vec();
//   dat2=dat1->clone_vec();
//   mod1->random();
//   dat2->random();
//   
//   
//
//
//  // fprintf(stderr,"INITIAL DATA\n");
////   mod1->info("Input mod",1);
////   dat2->info("Input dat",2);
//
//   forward(false,mod1,dat1);
//   double dot1=dat1->dot(dat2);
//   adjoint(false,mod2,dat2);
//   double dot2=mod2->dot(mod1);
//
//   verbPrt("Dot(add=false) %g %g \n",dot1,dot2);
//
//
//
//    
//   forward(true,mod1,dat1);
//   adjoint(true,mod2,dat2);
//
//
////  mod2->info("OUT mod",1);
// // dat1->info("OUR dat",2);
//   
//
//   double dot3=mod1->dot(mod2);
//   double dot4=dat1->dot(dat2);
//   verbPrt("Dot(add=true) %g %g \n",dot4,dot3);
//   
//   delete dat1; delete dat2; delete mod1; delete mod2;
//   
//   if(fabs(dot1) < 1e-12 || fabs(dot3) < 1e-12) {
//     verbPrt("Dot product suspiciously small\n");
//     
//     return false;
//   }
//   
//   if(fabs( (dot1-dot2)/dot1) >.0001) {
//     verbPrt("Failed add=false dot product %g %g\n",dot1,dot2);
//     return false;
//  }
//  
//  if(fabs( (dot3-dot4)/dot3) >.0001) {
//     verbPrt("Failed add=true dot product  %g (%g %g) \n",fabs( (dot3-dot4)/dot3),dot3,dot4);
//     return false;
//  }
//   return true;


